=== debian/changelog ===
nixnote2 (2.1.10+dfsg1-2build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:03:36 +1100

nixnote2 (2.1.10+dfsg1-2build3) noble; urgency=high

  * No change rebuild against libpoppler-qt5-1t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 18:18:09 +0100

nixnote2 (2.1.10+dfsg1-2build2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:47:54 +0000

nixnote2 (2.1.10+dfsg1-2build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:04:06 +0000

nixnote2 (2.1.10+dfsg1-2) unstable; urgency=medium

  * QA upload.
  * Orphan the package. (See #1064912)

 -- Boyuan Yang <byang@debian.org>  Tue, 27 Feb 2024 12:35:47 -0500

nixnote2 (2.1.10+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 04 Oct 2023 14:07:04 -0400
