=== debian/control ===
Source: nixnote2
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libavcodec-dev,
 libavformat-dev,
 libboost-dev,
 libcurl4-openssl-dev | libcurl-dev | libcurl4-nss-dev | libcurl4-gnutls-dev,
 libhunspell-dev,
 libpoppler-qt5-dev,
 libqt5webkit5-dev,
 libswscale-dev,
 libtidy-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev,
 qttools5-dev-tools,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/robert7/nixnote2
Vcs-Git: https://salsa.debian.org/debian/nixnote2.git
Vcs-Browser: https://salsa.debian.org/debian/nixnote2

Package: nixnote2
Architecture: any
Depends:
 libqt5sql5-sqlite,
 tidy,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 mimetex,
Suggests:
 cups,
Description: Open Source Evernote client
 NixNote is a client for the Evernote service (www.evernote.com).  It
 will allow synchronization and editing of notes from your local
 system.
 .
 Once known as "NeverNote", this software was rewritten in C++/Qt to
 provide a native user experience.
