=== debian/watch ===
version=4
opts="uversionmangle=s/-/~/,dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1" \
 https://github.com/robert7/nixnote2/tags /.*/.*/.*/v(.+)\.tar\.gz debian uupdate
